jQuery(document).ready(function() {
    var options = jQuery.parseJSON(SheepIt.options);
    var sheepItData = [];
    if(! _.isNull(options) && ! _.isNull(options.default_featured_image)){
        _.each(options.default_featured_image, function(value){
            sheepItData[sheepItData.length] = { 'url': value.url , 'category' : value.category };
        });
    }


    var category = jQuery.parseJSON(SheepIt.category);

    var sheepItForm = jQuery('#cfi_form').sheepIt({
        separator: '',
        allowRemoveLast: true,
        allowRemoveCurrent: true,
        allowRemoveAll: true,
        allowAdd: true,
        allowAddN: true,
        maxFormsCount: _.size(category),
        minFormsCount: 1,
        iniFormsCount: 0,
        data: sheepItData,
        beforeClone: function(source, newForm) {
            cat = [];
            jQuery("[id$='category']").each(function(){
                cat.push(jQuery(this).val());
                jQuery(this).prop('disabled', 'disabled');
            });

            jQuery(newForm).find("[id$='category']").prop('disabled', '');
            jQuery(newForm).find("[id$='url']").val('');
        },
        afterAdd: function(source, newform){

            index = jQuery("[id$='category']").length;
            if ( index <= sheepItData.length ){
                jQuery("[id$='category']").eq(index -1).val(sheepItData[index - 1].category);
            }

            jQuery(newform).find("[id$='category']").children().each(function(){
                if( jQuery.inArray(jQuery(this).val(), cat) != -1){
                    jQuery(this).remove();
                }
            });

            jQuery("[id$='category']:last").css('width', '200px' );
        }
    });

    jQuery('#cfi_form_remove_last').click( function(){
         jQuery("[id$='category']:last").prop('disabled', '');
    });

    jQuery('#cfi_form_remove_current').live('click', function(){
        exclude = [];
        last    = [];
        jQuery("[id$='category']").each(function(){
            exclude.push(jQuery(this).val());
        });
        current = jQuery("[id$='category']:last").val();

        exclude = _.without(exclude, current);

        var remains = _.omit(category, exclude);

        jQuery("[id$='category']:last").html('');
        _.each(remains, function(name, val){
            jQuery("[id$='category']:last").append("<option value="+val+">"+name+"</option>");
        });
        jQuery("[id$='category']:last").val(current);

        jQuery("[id$='category']:last").prop('disabled', '');
    });


    jQuery('#submit').click( function(){
         jQuery("[id$='category']").each( function() {
            jQuery(this).prop('disabled', '');
         });
    });

    jQuery("[id^=selector_default_featured_image]").live('click', function(){
        jQuery("[id$='url']").removeClass('target');

        jQuery(this).siblings("[id$='url']").addClass('target');
    })
});